<?php
/*------------------------------------------------------------------------------------//
* @File: 	simple-random.php
* @Package:	Simple Random Plugin 1.2
* @Action:	Plugin to insert random content into your theme
--------------------------------------------------------------------------------------*/

register_plugin(
	'simple-random',
	'Random Content Display',
	'1.2',
  	'Embrace Web',
  	'http://www.embraceweb.com/',
  	'Allows for random content to be displayed in a theme',
	'theme',
	'simple_random_setup'					
);

/*------------------------------------------------------------------------------------//
 * @function setup_plugin
 * Constructor file, maybe used later
//------------------------------------------------------------------------------------*/
function simple_random_setup() {
  // install random.php into /admin
  $file          = 'random.php';
  $initial       = 'random-sample.php';
  
  // check if random.php exists in admin section  
  if(!file_exists(GSADMINPATH.$file)) {
	if (copy(GSPLUGINPATH.'simple-random/'.$initial, GSADMINPATH.$file)) { }
  }
    
  // install meta xml into /data/other
  $meta          = 'simple-random-meta.xml';
  $metainitial   = 'simple-random-meta-sample.xml';
  
  // check if simple-random-meta.xml exists
  if(!file_exists(GSDATAOTHERPATH.$meta)) {
	if(copy(GSPLUGINPATH.'simple-random/'.$metainitial, GSDATAOTHERPATH.$meta)) {}
  }
  
  // install content xml into /data/other
  $content       = 'simple-random-content.xml';
  $contentinitial = 'simple-random-content-sample.xml';
  
  // check if simple-random-content.xml exists
  if(!file_exists(GSDATAOTHERPATH.$content)) {
	if(copy(GSPLUGINPATH.'simple-random/'.$contentinitial, GSDATAOTHERPATH.$content)) {}
  }
  
  // insert required CSS to set 'active' to the random content menu tab
  echo "
  <style type=\"text/css\">
    #random .wrapper .nav a.randomcontent {
      color:#182227;
	  background:#f9f9f9;
	  font-weight:bold !important;
	}
  </style>
  ";
}
/*------------------------------------------------------------------------------------//
 * @function simple_random_display
 * Display the content of the random file
 * $order - set the order of the display
//------------------------------------------------------------------------------------*/
function simple_random_display($order=1) {
  // grab simple analytics field
  $file = GSDATAOTHERPATH.'simple-random-content.xml';
  // check if file exists, if it does, display
  if (file_exists($file)){
    // grab XML data
	$data_edit = getXML($file);
	// set count of elements
	$count = count($data_edit)-1;
	// current number to display
    $random_number = rand(0, $count);	
	
	// display information from XML file based on random number position
	if($order == 2) {
	  echo htmlspecialchars_decode((string)$data_edit->content[$random_number]->contentinformation[0]);
	  echo htmlspecialchars_decode((string)$data_edit->content[$random_number]->contenttitle[0]);
	}
	else {
	   echo "<h2>".htmlspecialchars_decode((string)$data_edit->content[$random_number]->contenttitle[0])."</h2>";
	   echo "<div class='random_$random_number'>".htmlspecialchars_decode((string)$data_edit->content[$random_number]->contentinformation[0])."</div>";
//	  echo htmlspecialchars_decode((string)$data_edit->content[$random_number]->contentinformation[0]);
	}
  }
}

function simple_random_menu_add() {
  echo '<li><a accesskey="r" href="random.php" class="randomcontent">Random Content</a></li>';
}

function simple_random_create_admin_field() {
  global $tags;
  global $data_edit;
  $file = GSDATAOTHERPATH . 'simple-random-meta.xml';
  $id = "";

  // check if file exists, if so set ID number to current
  if (file_exists($file)){
    // grab file for information
    $data_edit = getXML($file);
    // set analytics ID
    $numberoffields = (string)$data_edit->numberoffields;
  }
  else {
    $numberoffields = "";
  }

  // add new field to the settings form
  echo '<p><b>Random Content - </b> Number of items to randomly display [<a href="random.php"><b>edit items</b></a>]<br>';
  echo '<input type="text" value="' . $numberoffields . '" name="numberoffields" class="text">';
  echo '</p>';
}

function simple_random_create_meta_xml() {
  // grab XML object
  global $xml;
  // grab simple analytics field
  $file = GSDATAOTHERPATH.'simple-random-meta.xml';
  // create XML File
  
  if($_POST['numberoffields'] != "") {
    $xml = @new SimpleXMLElement('<simplerandom></simplerandom>');
    $xml->addChild('numberoffields', $_POST['numberoffields']);
    $xml->asXML($file);
  }
  else {
    if (file_exists($file)){
      unlink($file);
    }
  }
}
add_action('header','simple_random_setup',array());
add_action('nav-tab','simple_random_menu_add',array());
add_action('settings-website-extras','simple_random_create_admin_field',array());
add_action('settings-cpsettings','simple_random_create_meta_xml',array());
?>