<?php
/****************************************************
*
* @File: 	random.php
* @Package:	GetSimple
* @Action:	Displays all random content fields
*
*****************************************************/
 
// Setup inclusions
$load['plugin'] = true;

// Relative
$relative = '../';

// Include common.php
include('inc/common.php');

// Variable settings
login_cookie_check();
$counter = '0';

// ---------------------------------------------------------------------------------------------------------------------//
// Save details is post, and display either way
// ---------------------------------------------------------------------------------------------------------------------//
if(file_exists(GSDATAOTHERPATH . 'simple-random-meta.xml') && file_exists(GSDATAOTHERPATH.'simple-random-content.xml')) {
  // get required number of fields
  $data_edit = getXML(GSDATAOTHERPATH . 'simple-random-meta.xml');
  $numberoffields = (string)$data_edit->numberoffields;

  // grab data from random file
  $data_edit = getXML(GSDATAOTHERPATH.'simple-random-content.xml');
  $currentfields = count($data_edit);


  // check if form is submitted
  if(isset($_POST["submitted"])) {
    $passed = $_POST;

	// unset incorrect values
    foreach($passed as $key => $value) {
      if($value == "" || $value == " " || is_null($value) || $key == "submitted") {
        unset($passed[$key]);
      }
    }
	
	// destroy original file
	unlink(GSDATAOTHERPATH.'simple-random-content.xml');
	// create base XML
    $xmlcontent = "<random>";
	// create count of returns
	$returncount = count($passed) / 2;
	// loop through items to create XML
	for($i=1; $i < $returncount+1; $i++) {
      $xmlcontent .= "<content>";
	  $xmlcontent .= "<contenttitle>" . htmlspecialchars(htmlentities($passed["contenttitle_$i"],ENT_QUOTES,'UTF-8'),ENT_QUOTES) . "</contenttitle>";
	  $xmlcontent .= "<contentinformation>" . htmlspecialchars(htmlentities($passed["contentinformation_$i"],ENT_QUOTES,'UTF-8'),ENT_QUOTES) . "</contentinformation>";
      $xmlcontent .= "</content>";
	}
	$xmlcontent .= "</random>";

    // convert to XML object
    $xml = new SimpleXMLElement($xmlcontent);
	// save XML file
   $xml->asXML(GSDATAOTHERPATH.'simple-random-content.xml');
   
   // reset to nothing
   $passed = null;
   
   // regrab file to regrab data after update
   $data_edit = getXML(GSDATAOTHERPATH . 'simple-random-content.xml'); 
   }
  
  // set empty string for displaying admin section
  $randomboxes = '';

  // loop through to create fields
  for($i=1; $i < $numberoffields+1; $i++) {
    // set variable based on xml read
    @ $contenttitle = (string)$data_edit->content[$i-1]->contenttitle[0];
	@ $contentinformation = (string)$data_edit->content[$i-1]->contentinformation[0];
    // add to line
    $randomboxes .= '
<div id="section-0" class="random" style="margin-bottom: 10px; margin-top: 10px;">
  <table class="random">
    <tbody>
	  <tr class="trodd">
	    <td>
		  <b>Random Item #' . $i . '</b>
		</td>
      </tr>
	  <tr>
	    <td>
  <b>Item Title:</b><br />
  <input type="text" name="contenttitle_' . $i . '" class="text" style="width: 580px;" value="' . stripslashes($contenttitle) . '" /><br />
  <b>Item Description:</b><br />
  <textarea name="contentinformation_' . $i . '" style="width: 580px; height: 100px;" class="text">' . stripslashes($contentinformation) . '</textarea><br />
        </td>
      </tr>
	</table>
</div>';
  }
}
// ---------------------------------------------------------------------------------------------------------------------//

?>
<?php get_template('header', cl($SITENAME).' &raquo; '."Random Content"); ?>

<h1><a href="<?php echo $SITEURL; ?>" target="_blank" ><?php echo cl($SITENAME); ?></a> <span>&raquo;</span> Random Content</h1>
<?php include('template/include-nav.php'); ?>
  <?php include('template/error_checking.php'); ?>
    <div class="bodycontent">
    <div id="maincontent">
      <div class="main" >
        <h3>Random Content</h3>
        <form action="random.php" method="post">
          <div class="clear"> <?php echo $randomboxes; ?> </div>
          <div class="clear">
            <p>
              <input class="submit" type="submit" name="submitted" value="Save Items" />
            </p>
          </div>
        </form>
      </div>
    </div>
    <div id="sidebar">
    <p><b>Random Content</b></p>
    <p>Please enter your random content items in the fields on the left and click <b>Save</b>.</p>
    <p>If you would like to increase, or decrease the number of items, go to the <a href="settings.php" title=""><b>Settings</b></a> page.</p>
    <?php if($currentfields > 0) { ?>
    <p>Current number of items: <?php echo "<b>".$currentfields."</b>"; ?></p>
    <?php } ?>
</div>
<div class="clear"></div>
</div>
<?php get_template('footer'); ?>