<?php
$gsg_plugins = array();  // used for option names
$gsg_pluginfiles = '';
$gsg_plugin_info = array();


add_action(GSG_PLUGINID.'-sidebar','sqr_createSideMenu',array(GSG_PLUGINID,'squareit_gsg_plugins',$i18n['SQR_GALLERY_SIDEMENU_PLUGINS']));


// include any plugins, depending on where the referring file that calls it we need to 
// set the correct paths. 

if (file_exists(GSG_PLUGINPATH)){
	$gsg_pluginfiles = getFiles(GSG_PLUGINPATH);
} 

$gsg_pluginsLoaded=false;

foreach ($gsg_pluginfiles as $gsgfile) 
{
	$gsg_pathExt = pathinfo($gsgfile,PATHINFO_EXTENSION );
	$gsg_pathName= pathinfo($gsgfile,PATHINFO_FILENAME );
	if ($gsg_pathExt=="php")
	{
		$gsg_pluginsLoaded=true;
		require_once(GSG_PLUGINPATH . $gsgfile);
	}
}

function gsg_register_plugin($id, $name, $ver=null, $auth=null, $auth_url=null, $desc=null, $type=null, $loaddata=null) {
	global $gsg_plugin_info;
	$gsg_plugin_info[$id] = array(
	  'name' => $name,
	  'version' => $ver,
	  'author' => $auth,
	  'author_url' => $auth_url,
	  'description' => $desc,
	  'page_type' => $type,
	  'load_data' => $loaddata
	);
}

/**
 * Interface that lists all the available plugins
 */
function squareit_gsg_plugins()
{
	global $gsg_plugin_info;
	global $i18n;
	$html = '<h3>'.$i18n['PLUGINS_MANAGEMENT'].'</h3>';
	$html .= '<table class="edittable highlight paginate">';
	$counter = 0;
	foreach ($gsg_plugin_info as $plugin)
	{
		$html .= '<tr id="tr-'.$counter.'" >';
		$html .= '<td width="25%" ><b>'.$plugin['name'] .'</b></td>';
		$html .= '<td><span>'.$plugin['description'] .'<br />';
		$html .= $i18n['PLUGIN_VER'] .' '. $plugin['version'].' &nbsp;|&nbsp; By <a href="'.$plugin['author_url'].'" target="_blank">'.$plugin['author'].'</a></span></td>';
		$html .= "</tr>\n";
		$counter++;	
	}
	$html .= '</table>';
	
	echo $html;
}
