<?php
/*
 Name: Admin Tab Loader
 Description: Allows plugins to create admin tabs and use full content canvas and side bar.
 Version: 1.0.0
 Author: Julian Castaneda (Square IT Solutions)
 Author URI: http://www.squareitsol.com/
 */

# get correct id for plugin
$thisfile=basename(__FILE__, ".php");

add_action('header','squareit_tabLoadStyle',array());

# register plugin
register_plugin(
	$thisfile,
	'Admin Tab Loader',
	'1.1',
	'Square IT Solutions',
	'http://www.squareitsol.com/',
	'Description: Allows plugins to create admin tabs and use full content canvas and side bar.',
	'plugins', //page type
	'squareit_setup_loadtab'
);

//install loadtab.php into /admin
$file = 'loadtab.php';
//check if random.php exists in admin section
if(!file_exists(GSADMINPATH.$file)) {
	if (!@copy(GSPLUGINPATH.'squareit-loadtab/'.$file, GSADMINPATH.$file)) 
	{ 
		//attempt to change permissions
		if (chmod(GSADMINPATH, 0777))
		{
			if (!@copy(GSPLUGINPATH.'squareit-loadtab/'.$file, GSADMINPATH.$file))
			{ 
				squareit_msg_box('Unable to copy loadtab.php into the admin directory. Please copy "loadtab.php" file under the "squareit-loadtab" folder into the "admin" folder directly.', 'error');
			}
		}
		else
		{
			squareit_msg_box('Unable to override permissions of admin folder. Please copy "loadtab.php" file under the "squareit-loadtab" folder into the "admin" folder directly.', 'error');
		}
	}
}

function squareit_setup_loadtab(){}

/**
 * Creates a new style for selected tab item
 */
function squareit_tabLoadStyle()
{
	?>
	<style>
		.tabSelected {
			background: #F9F9F9 !important;
			color: #182227 !important;;
		}
	</style>
	<?php
}

/**
 * @function sqr_createSideMenu
 * @param $plugin  	- Plugin Name
 * @param $item  	- Plugin Sub Item
 * @param $txt     	- text to display on link
 *
 */
function sqr_createSideMenu($plugin, $item ,$txt){
	$class="";
	if (@$_GET['item'] == @$item) {
		$class='class="current"';
	}

	echo '<li><a href="loadtab.php?id='.$plugin.'&item='.$item.'" '.$class.' >'.$txt.'</a></li>';
}



/**
 * @function sqr_createNavTab
 * @param $plugin  	- Plugin Name
 * @param $txt 		- text to display on link
 */
function sqr_createNavTab($plugin,$txt) {
	$class = '';
	if (@$_GET['id'] == @$plugin) {
		$class='class="tabSelected"';
	}
	echo '<li><a href="loadtab.php?id='.$plugin.'&item='.$plugin.'" '.$class.' >';
	echo $txt;
	echo "</a></li>";
}

/**
 *  Generates a message box
 *  - Prepare it so that it can be used across all square it plugins
 */
if (!function_exists('squareit_msg_box'))
{
	function squareit_msg_box($msg, $type='updated')
	{
		echo '<div class="'.$type.'"> 
				'.$msg.' 
			 </div>';
	}
}
